fd74051e90f54a9e1eafaaf4b4fdd4e8d9250b04
[xfstests-dev.git] / common.config
1 ##/bin/sh
2 #
3 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of version 2 of the GNU General Public License as
7 # published by the Free Software Foundation.
8
9 # This program is distributed in the hope that it would be useful, but
10 # WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
12
13 # Further, this software is distributed without any warranty that it is
14 # free of the rightful claim of any third person regarding infringement
15 # or the like.  Any license provided herein, whether implied or
16 # otherwise, applies only to this software file.  Patent licenses, if
17 # any, provided herein do not apply to combinations of this program with
18 # other software, or any other product whatsoever.
19
20 # You should have received a copy of the GNU General Public License along
21 # with this program; if not, write the Free Software Foundation, Inc., 59
22 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
23
24 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
25 # Mountain View, CA  94043, or:
26
27 # http://www.sgi.com 
28
29 # For further information regarding this notice, see: 
30
31 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
32 #
33
34 #
35 # setup and check for config parameters, and in particular
36 #
37 # TEST_DIR              - scratch test directory that is in an already
38 #                         mounted XFS file system, needs to be be world
39 #                         writeable
40 # TEST_DEV              - device for file system containing TEST_DIR
41 # SCRATCH_DEV           - device you can make a scratch file system on
42 # SCRATCH_MNT           - mount point for scratch file system
43
44 # and optionally:
45 # SCRATCH_LOGDEV        - scratch log device for external log testing
46 # SCRATCH_RTDEV         - scratch rt dev
47 # TEST_LOGDEV           - test log device for external log testing
48 # TEST_RTDEV            - test rt dev
49 # TAPE_DEV              - the tape device for the xfsdump tests
50 # RMT_TAPE_DEV          - the remote tape device for the xfsdump tests
51 # RMT_IRIXTAPE_DEV      - the IRIX remote tape device for the xfsdump tests
52 # RMT_TAPE_USER         - remote user for tape device
53 #
54 # - These can be added to known_hosts() below or a separate local
55 #   configuration file can be used (using the HOST_OPTIONS variable).
56 # - This script is shared by the stress test system and the auto-qa
57 #   system (includes both regression test and benchmark components).
58 # - TEST_DEV & TEST_DIR must be assigned.
59 # - this script shouldn't make any assertions about filesystem
60 #   validity or mountedness.
61 #
62
63 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
64 #          get the wrong hostname and set your system name to -s  :)
65 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
66 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
67 PATH=".:$PATH"
68
69 HOST=`hostname -s`
70 HOSTOS=`uname -s`
71 [ "$HOSTOS" = "IRIX64" ] && HOSTOS="IRIX"
72
73 MODULAR=0               # using XFS as a module or not
74 BOOT="/boot"            # install target for kernels
75 export EXTRA=${EXTRA:=xfs-qa}
76
77 # general parameters (mainly for auto-qa)
78 SOAK_PROC=3             # -p option to fsstress
79 SOAK_STRESS=10000       # -n option to fsstress
80 SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
81 EMAIL=root@localhost    # where auto-qa will send its status messages
82 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
83 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
84 export BENCH_PASSES=${BENCH_PASSES:=5}
85 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
86
87 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
88 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
89 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
90
91 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
92 set_prog_path()
93 {
94     p=`which $1 2> /dev/null`
95     if [ -n "$p" -a -x "$p" ]
96     then
97         echo $p
98         return 0
99     fi
100     p=$1
101
102     shift
103     for f
104     do
105         if [ -x $f ]
106         then
107             echo $f
108             return 0
109         fi
110     done
111
112     echo ""
113     return 1
114 }
115
116 _fatal()
117 {
118     echo "$*"
119     status=1
120     exit 1
121 }
122
123 export MKFS_PROG="`set_prog_path mkfs`"
124 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
125
126 export AWK_PROG="`set_prog_path awk`"
127 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
128
129 export MOUNT_PROG="`set_prog_path mount`"
130 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
131
132 export UMOUNT_PROG="`set_prog_path umount`"
133 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
134
135 export NSLOOKUP_PROG="`set_prog_path nslookup`"
136 [ "$NSLOOKUP_PROG" = "" ] && _fatal "nslookup not found"
137
138 export PERL_PROG="`set_prog_path perl`"
139 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
140
141 export SED_PROG="`set_prog_path sed`"
142 [ "$SED_PROG" = "" ] && _fatal "sed not found"
143
144 export PS_ALL_FLAGS="-ef"
145
146 export DF_PROG="`set_prog_path df`"
147 [ "$DF_PROG" = "" ] && _fatal "df not found"
148 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T"
149
150 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
151 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
152 export XFS_CHECK_PROG="`set_prog_path xfs_check`"
153 export XFS_DB_PROG="`set_prog_path xfs_db`"
154
155 case "$HOSTOS" in
156     IRIX*)
157            export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
158            export MKFS_UDF_PROG="`set_prog_path mkfs_udf`" 
159            export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
160            export MKFS_NFS_PROG="false" 
161            ;;
162     Linux)
163            export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
164            export MKFS_UDF_PROG="`set_prog_path mkudffs`"
165            export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
166            export MKFS_NFS_PROG="false" 
167            ;;
168 esac
169
170 known_hosts()
171 {
172         case "$HOST"
173         in
174             bruce)
175                 MODULAR=0
176                 EMAIL="nathans@larry"
177                 SCRATCH_MNT=/mnt/xfs0
178                 SCRATCH_DEV=/dev/sdb5
179                 #SCRATCH_RTDEV=/dev/sdc1
180                 SCRATCH_LOGDEV=/dev/sda11
181                 TEST_DIR=/mnt/xfs1
182                 TEST_DEV=/dev/sdc3
183                 #TEST_RTDEV=/dev/sdb6
184                 TEST_LOGDEV=/dev/sda9
185                 TAPE_DEV=/dev/st0
186                 RMT_TAPE_DEV=bruce:/dev/st0
187                 RMT_IRIXTAPE_DEV=snort:/dev/tape
188                 RMT_TAPE_USER=guest
189                 ;;
190             sherman)
191                 TEST_DEV=/dev/sda10
192                 TEST_DIR=/mnt/xfs1
193                 SCRATCH_DEV=/dev/sda9
194                 SCRATCH_MNT=/mnt/xfs0
195                 ;;
196             flutz)
197                 MODULAR=0
198                 EMAIL="nathans@larry"
199                 TEST_DEV=/dev/sda5
200                 TEST_LOGDEV=/dev/sda9
201                 TEST_DIR=/xfsqa1
202                 SCRATCH_DEV=/dev/sda6
203                 SCRATCH_LOGDEV=/dev/sda7
204                 SCRATCH_MNT=/xfsqa2
205                 TAPE_DEV=/dev/st0
206                 RMT_TAPE_DEV=bruce:/dev/st0
207                 RMT_IRIXTAPE_DEV=snort:/dev/tape
208                 RMT_TAPE_USER=guest
209                 ;;
210             frodo)
211                 MODULAR=0
212                 EMAIL="nathans@larry"
213                 TEST_DEV=/dev/hda6
214                 TEST_DIR=/mnt/test
215                 SCRATCH_DEV=/dev/hda7
216                 SCRATCH_MNT=/mnt/scratch
217                 SCRATCH_LOGDEV=/dev/hda9
218                 ;;
219             goldfish)
220                 MODULAR=0
221                 TEST_DEV=/dev/hdc1
222                 TEST_DIR=/mnt/xfs0
223                 SCRATCH_DEV=/dev/hdc2
224                 SCRATCH_MNT=/mnt/xfs1
225                 SCRATCH_LOGDEV=/dev/hdc3
226                 ;;
227             lord)
228                 TEST_DIR=/xfs
229                 TEST_DEV=/dev/sda1
230                 SCRATCH_DEV=/dev/sda5
231                 SCRATCH_LOGDEV=/dev/sda6
232                 SCRATCH_MNT=/xfs1
233                 ;;
234             burst)
235                 TEST_DIR=/xfs
236                 TEST_DEV=/dev/hda3
237                 SCRATCH_DEV=/dev/hda7
238                 SCRATCH_MNT=/scratch
239                 ;;
240             lumpy)
241                 TEST_DEV=/dev/sdc5
242                 TEST_DIR=/mnt/scratch_0
243                 SCRATCH_DEV=/dev/sdc7
244                 SCRATCH_MNT=/mnt/scratch_2
245                 ;;
246             bongo)
247                 TEST_DEV=/dev/hda8
248                 TEST_DIR=/xfs1
249                 SCRATCH_DEV=/dev/hda9
250                 SCRATCH_MNT=/xfs2
251                 SCRATCH_LOGDEV=/dev/hda10
252                 SCRATCH_RTDEV=/dev/hda11
253                 ;;
254             surly)
255                 TEST_DEV=/dev/hda9
256                 TEST_DIR=/mnt/xfs1
257                 SCRATCH_DEV=/dev/hda8
258                 SCRATCH_MNT=/mnt/xfs0
259                 SCRATCH_LOGDEV=/dev/hda10
260                 TAPE_DEV=/dev/st0
261                 RMT_TAPE_DEV=fuzzy:/dev/st0
262                 RMT_IRIXTAPE_DEV=blub:/dev/tape
263                 RMT_TAPE_USER=guest
264                 ;;
265             permit)
266                 TEST_DEV=/dev/sdc1
267                 TEST_DIR=/mnt/xfs0
268                 SCRATCH_DEV=/dev/sdd1
269                 SCRATCH_MNT=/mnt/xfs1
270                 ;;
271             indra)
272                 TEST_DEV=/dev/sdb1
273                 TEST_DIR=/mnt/xfs0
274                 SCRATCH_DEV=/dev/sdb2
275                 SCRATCH_MNT=/mnt/xfs1
276                 ;;
277             usermode)
278                 TEST_DEV=/dev/ubd/1
279                 TEST_DIR=/mnt/test
280                 SCRATCH_DEV=/dev/ubd/2
281                 SCRATCH_MNT=/mnt/scratch
282                 SCRATCH_RTDEV=/dev/ubd/3
283                 SCRATCH_LOGDEV=/dev/ubd/4
284                 ;;
285             lite)
286                 TEST_DEV=/dev/sda1
287                 TEST_DIR=/mnt/sda1
288                 SCRATCH_DEV=/dev/sda2
289                 SCRATCH_MNT=/mnt/sda2
290                 SCRATCH_LOGDEV=/dev/sda3
291                 SCRATCH_RTDEV=/dev/sda4
292                 ;;
293             dmfnt2)
294                 TEST_DEV=/dev/sda6
295                 TEST_DIR=/mnt/test
296                 SCRATCH_DEV=/dev/sdc6
297                 SCRATCH_MNT=/mnt/scratch
298                 TAPE_DEV=/dev/st0
299                 RMT_TAPE_DEV=longhorn:/dev/tape
300                 # RMT_IRIXTAPE_DEV=longhorn:/dev/tape
301                 RMT_TAPE_USER=guest
302                 ;;
303             lab343)
304                 MODULAR=0
305                 EMAIL="hch@sgi.com"
306                 TEST_DEV=/dev/sdb1
307                 SCRATCH_DEV=/dev/sdb2
308                 SCRATCH_LOGDEV=/dev/sdb5
309                 SCRATCH_RTDEV=/dev/sdb6
310                 TEST_DIR=/qa/test
311                 SCRATCH_MNT=/qa/scratch
312                 ;;
313             icy)
314                 MODULAR=0
315                 EMAIL="ajones@sgi.com"
316                 TEST_DIR=/mnt/test
317                 TEST_DEV=/dev/sda3
318                 #TEST_LOGDEV=/dev/sda9
319                 #TEST_RTDEV=/dev/sda10
320                 SCRATCH_MNT=/mnt/scratch
321                 #SCRATCH_DEV=emu:/mnt/scratch
322                 SCRATCH_DEV=/dev/sda5
323                 SCRATCH_LOGDEV=/dev/sda8
324                 SCRATCH_RTDEV=/dev/sda7
325                 TAPE_DEV=/dev/st0
326                 RMT_IRIXTAPE_DEV=snort:/dev/tape
327                 RMT_TAPE_DEV=icy:/dev/st0
328                 RMT_TAPE_USER=guest
329                 ;;
330             dribble)
331                 MODULAR=0
332                 EMAIL="ajones@sgi.com"
333                 TEST_DIR=/mnt/test
334                 TEST_DEV=/dev/dsk/dks0d2s0
335                 #TEST_LOGDEV=
336                 SCRATCH_MNT=/mnt/scratch
337                 #SCRATCH_DEV=emu:/mnt/scratch
338                 SCRATCH_DEV=/dev/dsk/dks0d2s1
339                 #SCRATCH_LOGDEV=
340                 #SCRATCH_RTDEV=
341                 TAPE_DEV=/dev/tape
342                 RMT_TAPE_DEV=icy:/dev/st0
343                 RMT_TAPE_USER=guest
344                 RMT_IRIXTAPE_DEV=snort:/dev/tape        
345                 ;;
346             emu)
347                 MODULAR=0
348                 EMAIL="ajones@sgi.com"
349                 TEST_DIR=/mnt/test
350                 TEST_DEV=/dev/sdb1
351                 SCRATCH_MNT=/mnt/scratch
352                 SCRATCH_DEV=/dev/sdb2
353                 ;;
354             inferno)
355                 MODULAR=0
356                 EMAIL="ajones@sgi.com"
357                 TEST_DIR=/mnt/test
358                 TEST_DEV=/dev/sdb1
359                 SCRATCH_MNT=/mnt/scratch
360                 SCRATCH_DEV=/dev/sdb2
361                 ;;
362
363             *)  
364                 echo "Error: need to define parameters for host $HOST"
365                 exit 1
366                 ;;
367         esac
368 }
369
370 if [ -f "$HOST_OPTIONS" ]; then
371     . "$HOST_OPTIONS"
372 else
373     known_hosts
374 fi
375
376 echo $TEST_DEV | grep -q ":" > /dev/null 2>&1
377 if [ ! -b "$TEST_DEV" -a "$?" != "0" ]
378 then
379     echo "common.config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a NFS filesystem"
380     exit 1
381 fi
382
383 if [ ! -d "$TEST_DIR" ]
384 then
385     echo "common.config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
386     exit 1
387 fi
388
389 echo $SCRATCH_DEV | grep -q ":" > /dev/null 2>&1
390 if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]
391 then
392     echo "common.config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a NFS filesystem"
393     exit 1
394 fi
395
396 if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]
397 then
398     echo "common.config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
399     exit 1
400 fi
401
402 _readlink()
403 {
404     if [ $# -ne 1 ]
405     then
406         echo "Usage: _readlink filename" 1>&2
407         exit 1
408     fi
409
410     perl -e "\$in=\"$1\";" -e '
411         $lnk = readlink($in);
412         if ($lnk =~ m!^/.*!) {
413           print "$lnk\n";
414         }
415         else {
416           chomp($dir = `dirname $in`);
417           print "$dir/$lnk\n";
418         }'
419 }
420
421 # if devfs is running expand the full /dev/.. pathname - this is what will be
422 # returned by utilities such as mount
423 [ -L "$TEST_DEV" ] && TEST_DEV=`_readlink $TEST_DEV`
424 [ -L "$SCRATCH_DEV" ] && SCRATCH_DEV=`_readlink $SCRATCH_DEV`
425 [ -L "$SCRATCH_LOGDEV" ] && SCRATCH_LOGDEV=`_readlink $SCRATCH_LOGDEV`
426 [ -L "$SCRATCH_RTDEV" ] && SCRATCH_RTDEV=`_readlink $SCRATCH_LOGDEV`
427
428 # make sure this script returns success
429 /bin/true